Attribute VB_Name = "SaveRestorFileInMDB"
Option Explicit

Public Const BlockSize = 32768
Public Function ReadBLOB(Source As String, T As Recordset, sField As String)
          Dim NumBlocks As Integer, SourceFile As Integer, i As Integer
          Dim FileLength As Long, LeftOver As Long
          Dim lngMeter As Long
          Dim FileData As String
          Dim byteData() As Byte
          Dim RetVal As Variant

          On Error GoTo Err_ReadBLOB
            
          SourceFile = FreeFile
          Open Source For Binary Access Read As SourceFile

   
            FileLength = LOF(SourceFile)
          If FileLength = 0 Then
              ReadBLOB = 0
              Exit Function
          End If

          NumBlocks = FileLength \ BlockSize

          LeftOver = FileLength Mod BlockSize

          If LeftOver > 0 Then
            
            ReDim byteData(0 To LeftOver - 1)
            Get SourceFile, , byteData
            'T.Edit
                T(sField).AppendChunk (byteData)
            'T.Update
          End If
           
          ReDim byteData(0 To BlockSize - 1)
          For i = 1 To NumBlocks
              Get SourceFile, , byteData
              T(sField).AppendChunk (byteData)
          Next i
          
          Close SourceFile
          ReadBLOB = FileLength
          Exit Function

Err_ReadBLOB:
          ReadBLOB = -Err
          MsgBox Err.Description, , Err.Number
          Exit Function

      End Function
     
     
     
     Function WriteBLOB(T As Recordset, sField As String, Destination As String)
          Dim NumBlocks As Integer, DestFile As Integer, i As Integer
          Dim FileLength As Long, LeftOver As Long
          Dim lngMeter As Long
          Dim byteData() As Byte
          Dim RetVal As Variant

          On Error GoTo Err_WriteBLOB

             FileLength = T(sField).FieldSize()
          If FileLength = 0 Then
              WriteBLOB = 0
              Exit Function
          End If

          NumBlocks = FileLength \ BlockSize
          LeftOver = FileLength Mod BlockSize

          DestFile = FreeFile
          Open Destination For Output As DestFile
          Close DestFile
          
          Open Destination For Binary As DestFile
          
          If LeftOver > 0 Then
            byteData() = T(sField).GetChunk(0, LeftOver)
            Put DestFile, , byteData
          End If
          
          For i = 1 To NumBlocks
              byteData() = T(sField).GetChunk((i - 1) * BlockSize + LeftOver, BlockSize)
              Put DestFile, , byteData
          Next i
               Close DestFile
               WriteBLOB = FileLength
          Exit Function

Err_WriteBLOB:
          WriteBLOB = -Err
          MsgBox Err.Description, vbCritical, Err.Number
          Exit Function

      End Function

